//****************************************************************************
// @Module        Shared Interrupt Routines
// @Filename      SHARED_INT.C
// @Project       Int2.dav
//----------------------------------------------------------------------------
// @Controller    Infineon XC888CLM-8FF
//
// @Compiler      Keil
//
// @Codegenerator 1.2
//
// @Description   This file contains the Shared interrupt routines.
//
//----------------------------------------------------------------------------
// @Date          10.04.2008 10:43:16
//
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,1)

// USER CODE END



//****************************************************************************
// @Project Includes
//****************************************************************************

#include "SHARED_INT.H"

// USER CODE BEGIN (SHARED_INT_General,2)

// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,5)

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,6)

// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,7)

// USER CODE END


//****************************************************************************
// @External Prototypes
//****************************************************************************


// USER CODE BEGIN (SHARED_INT_General,8)

// USER CODE END


//****************************************************************************
// @Prototypes Of Local Functions
//****************************************************************************

// USER CODE BEGIN (SHARED_INT_General,9)

// USER CODE END


//****************************************************************************
// @Function      void SHINT_vInit(void) 
//
//----------------------------------------------------------------------------
// @Description   This function initializes the shared interrupts. 
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          10.04.2008
//
//****************************************************************************

// USER CODE BEGIN (SHINT_Init,1)

// USER CODE END

void SHINT_vInit(void)
{
  // USER CODE BEGIN (SHINT_Init,2)

  // USER CODE END

  ///  -----------------------------------------------------------------------
  ///  Configuration of the Shared  Interrupts:
  ///  -----------------------------------------------------------------------
  ///  - External Interrupt 2 is Selected


  IEN1         |=  0x04;         // load interrupt enable register 1


  // USER CODE BEGIN (SHINT_Init,3)

  // USER CODE END


} //  End of function SHINT_vInit


//****************************************************************************
// @Function      void SHINT_viXINTR8Isr(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the service routine for the shared interrupt node 
//                XINTR8. XINTR8 ISR Node is shared by External Interrupt 
//                2,Timer 21,CORDIC,UART1,UART1 Fractional Divider(BRG 
//                Interrupt), and MDU[1:0]. Depending on the selected module 
//                interrupt it is called. 
//                EXT2 - It is called for the External interrupt 2. 
//                T21 - Depending on the selected operating mode it is called 
//                when TF2 is set by an overflow or underflow of the timer 21 
//                register or when EXF2 is set by a negative transition on 
//                T2EX.
//                UART1 - It is called after the BRG timer overflows and sets 
//                the NDOV bit.
//                It is called after each transmission (flag TI_1 set) or 
//                reception (flag RI_1 set) of a data unit.
//                Please note that you have to add application specific code 
//                to this function.
//
//----------------------------------------------------------------------------
// @Returnvalue   none
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          10.04.2008
//
//****************************************************************************

//   You have two choices for interrupt type select in Project Settings Page 
//   under Global Settings Section.
//   If you select CHOICE 1 then ISR will be generated with push and pop.
//   If you select CHOICE 2 then ISR will be generated without push and pop.
//   Default choice is CHOICE 2.
//   Current selection is CHOICE 2 

// USER CODE BEGIN (SHINT_XINTR8Isr,1)

// USER CODE END

void SHINT_viXINTR8Isr(void) interrupt XINTR8INT
{

  // USER CODE BEGIN (SHINT_XINTR8Isr,2)

  // USER CODE END

  SFR_PAGE(_su0, SST0);          // switch to page0

  //   External Interrupt 2 handling section...

  if (((IRCON0 & 0x04) != 0))
  {
    //   External interrupt 2 has occured

    IRCON0 &= ~(ubyte)0x04; //   clear EXINT2

    // USER CODE BEGIN (SHINT_XINTR8Isr,3)
	   get_hallinfo();
    // USER CODE END

  }

  // USER CODE BEGIN (SHINT_XINTR8Isr,9)

  // USER CODE END


  SFR_PAGE(_su0, RST0);          // restore the old SCU page

} //  End of function SHINT_viXINTR8Isr


// USER CODE BEGIN (SHARED_INT_General,10)

// USER CODE END


